#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<malloc.h>

//Ϊ10^8
#define MAX_step 100000000

//Q_n^{-1} Q_{n-1}^{-1}...Q_1^{-1}x=Ix=Q_1 Q_2 Q_3...Q_n
int Jacobi(double **a, int n, double epsilon, double *r, double **v){
    int i,j,p,q;
    double s,t,c,d,ap,aq;
    double *P,*Q;
    P=(double *)malloc(n*sizeof(double));
    Q=(double *)malloc(n*sizeof(double));
    //v=I
    for(i=0;i<n;i++)
        for(j=0;j<n;j++)
            v[i][j]=(i==j);
    int step;
    for(step=1;step<=MAX_step;step++){
        //ѡȡǶԽ߰ģԪ
        p=0;
        q=1;
        for(i=0;i<n;i++){
            for(j=0;j<n;j++){
                if(i==j) continue;
                if( fabs(a[p][q])<fabs(a[i][j]) ){
                    p=i;
                    q=j;
                }
            }
        }
        //ȷתǶthetat=tan(theta)
        if(a[p][q]!=0){
            s=(a[q][q]-a[p][p])/(2*a[p][q]);
            if(s>=0)
                t=-s+sqrt(1+s*s);
            else
                t=-s-sqrt(1+s*s);
            // c=cos(theta), d=sin(theta)
            c=1/sqrt(1+t*t);
            d=t*c;
        }
        else{
            c=1;
            d=0;
        }
        //A'=Q^TAQֵr
        for(i=0;i<n;i++){
            if(i!=p && i!=q){
                ap=a[p][i];
                aq=a[q][i];
                a[p][i]=c*ap-d*aq;
                a[i][p]=a[p][i];
                a[q][i]=c*aq+d*ap;
                a[i][q]=a[q][i];
            }
        }
        a[p][p]=a[p][p]-t*a[p][q];
        a[q][q]=a[q][q]+t*a[p][q];
        a[p][q]=a[q][p]=0;
        for(i=0;i<n;i++)
            r[i]=a[i][i];
        //v
        for(i=0;i<n;i++){
            P[i]=c*v[i][p]-d*v[i][q];
            Q[i]=c*v[i][q]+d*v[i][p];
        }
        for(i=0;i<n;i++){
            v[i][p]=P[i];
            v[i][q]=Q[i];
        }
        //жǷھȷΧ
        s=0;
        for(i=0;i<n;i++){
            for(j=0;j<n;j++){
                if(i==j) continue;
                s+=a[i][j]*a[i][j];
            }
        }
        //ﵽҪֹͣ
        if(s<=epsilon)
            break;
    }
    //ͷڴ
    free(P);
    free(Q);
    //жǷҵ
    if(step>MAX_step)
        return 0;
    else
        return 1;
}

int main(void){
    //ɵ
    int n=5;
    //ɵƾȣΪ10^(-7)
    double epsilon=1E-7;
    //ԭ
    double A[5][5]={  \
    { 3, 2, 5, 4, 6}, \
    { 2, 1, 3,-7, 8}, \
    { 5, 3, 2, 5,-4}, \
    { 4,-7, 5, 1, 3}, \
    { 6, 8,-4, 3, 8}, \
    };
    //̬ڴ淽Ϊͨó򴫲
    double **a,**v,*r;
    a=(double **)malloc(n*sizeof(double *));
    v=(double **)malloc(n*sizeof(double *));
    r=(double *)malloc(n*sizeof(double));
    int i,j;
    for(i=0;i<n;i++){
        a[i]=(double *)malloc(n*sizeof(double));
        v[i]=(double *)malloc(n*sizeof(double));
    }
    //aΪ̬ԭv[i]ֵr[i]Ӧָ
    for(i=0;i<n;i++){
        r[i]=0;
        for(j=0;j<n;j++)
            a[i][j]=A[i][j];
    }
    //ִвж
    if( !Jacobi(a,n,epsilon,r,v) ){
        //ͷڴ
        for(i=0;i<n;i++){
            free(a[i]);
            free(v[i]);
        }
        free(a);
        free(v);
        free(r);
        printf("ʧܣ\n");
        system("pause");
        return 0;
    }
    //
    for(i=0;i<n;i++){
        printf("r%d=%.15E\nv%d=(",(i+1),r[i],(i+1) );
        for(j=0;j<n-1;j++)
            printf("%.15E,",v[j][i]);
        printf("%.15E)\n\n",v[n-1][i]);
    }
    //ͷڴ
    for(i=0;i<n;i++){
        free(a[i]);
        free(v[i]);
    }
    free(a);
    free(v);
    free(r);
    //ͣ
    system("pause");
    return 0;
}
