(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     17268,        446]
NotebookOptionsPosition[     14594,        402]
NotebookOutlinePosition[     14951,        418]
CellTagsIndexPosition[     14908,        415]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"phi", "[", "x_", "]"}], "=", 
   RowBox[{"x", "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"x", "^", "3"}], "/", "3"}], "-", "x"}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"x", "^", "2"}], "-", "1"}], ")"}]}]}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"phi1", "[", "x_", "]"}], "=", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"phi", "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "1"}], "}"}]}], "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"phi2", "[", "x_", "]"}], "=", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"phi", "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "2"}], "}"}]}], "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"phi3", "[", "x_", "]"}], "=", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"phi", "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "3"}], "}"}]}], "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"phi1", "[", "0", "]"}], "\[IndentingNewLine]", 
 RowBox[{"phi2", "[", "0", "]"}], "\[IndentingNewLine]", 
 RowBox[{"phi3", "[", "0", "]"}], "\[IndentingNewLine]", 
 RowBox[{"phi1", "[", 
  RowBox[{"-", 
   RowBox[{"Sqrt", "[", "3", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"phi2", "[", 
  RowBox[{"-", 
   RowBox[{"Sqrt", "[", "3", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"phi3", "[", 
  RowBox[{"-", 
   RowBox[{"Sqrt", "[", "3", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"phi1", "[", 
  RowBox[{"Sqrt", "[", "3", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"phi2", "[", 
  RowBox[{"Sqrt", "[", "3", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"phi3", "[", 
  RowBox[{"Sqrt", "[", "3", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.751286743614441*^9, 3.7512868395037923`*^9}, {
  3.751286884621809*^9, 3.751286969925508*^9}, {3.75128700290739*^9, 
  3.751287004366996*^9}, {3.75134678227247*^9, 3.751346810614417*^9}, {
  3.7513759882361765`*^9, 3.7513760173359375`*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"c0de3039-c059-4098-835a-6ad21893b685"],

Cell[BoxData[
 FractionBox[
  RowBox[{"2", " ", 
   SuperscriptBox["x", "3"]}], 
  RowBox[{"3", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox["x", "2"]}], ")"}]}]]], "Output",
 CellChangeTimes->{
  3.7512869720591235`*^9, 3.7512870058660774`*^9, 3.7513458151611423`*^9, 
   3.751346831569708*^9, {3.751375991843026*^9, 3.751376019087427*^9}},
 CellLabel->"Out[14]=",ExpressionUUID->"5d0f6633-8005-4cab-8331-56975a0cf2a2"],

Cell[BoxData[
 FractionBox[
  RowBox[{"2", " ", 
   SuperscriptBox["x", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "3"}], "+", 
     SuperscriptBox["x", "2"]}], ")"}]}], 
  RowBox[{"3", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["x", "2"]}], ")"}], "2"]}]]], "Output",
 CellChangeTimes->{
  3.7512869720591235`*^9, 3.7512870058660774`*^9, 3.7513458151611423`*^9, 
   3.751346831569708*^9, {3.751375991843026*^9, 3.7513760190968513`*^9}},
 CellLabel->"Out[15]=",ExpressionUUID->"68724f49-a022-425b-b398-adde57df892b"],

Cell[BoxData[
 FractionBox[
  RowBox[{"4", " ", "x", " ", 
   RowBox[{"(", 
    RowBox[{"3", "+", 
     SuperscriptBox["x", "2"]}], ")"}]}], 
  RowBox[{"3", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["x", "2"]}], ")"}], "3"]}]]], "Output",
 CellChangeTimes->{
  3.7512869720591235`*^9, 3.7512870058660774`*^9, 3.7513458151611423`*^9, 
   3.751346831569708*^9, {3.751375991843026*^9, 3.7513760191052833`*^9}},
 CellLabel->"Out[16]=",ExpressionUUID->"7cc1dbcc-e3e4-4660-ac04-b04f26c610af"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"6", " ", 
       SuperscriptBox["x", "2"]}], "+", 
      SuperscriptBox["x", "4"]}], ")"}]}], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["x", "2"]}], ")"}], "4"]]}]], "Output",
 CellChangeTimes->{
  3.7512869720591235`*^9, 3.7512870058660774`*^9, 3.7513458151611423`*^9, 
   3.751346831569708*^9, {3.751375991843026*^9, 3.7513760191137147`*^9}},
 CellLabel->"Out[17]=",ExpressionUUID->"872a1c0d-825d-456a-98d6-39fc93857a23"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.7512869720591235`*^9, 3.7512870058660774`*^9, 3.7513458151611423`*^9, 
   3.751346831569708*^9, {3.751375991843026*^9, 3.7513760191206636`*^9}},
 CellLabel->"Out[18]=",ExpressionUUID->"60851557-4efc-4eb3-83ae-c511664f59cb"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.7512869720591235`*^9, 3.7512870058660774`*^9, 3.7513458151611423`*^9, 
   3.751346831569708*^9, {3.751375991843026*^9, 3.751376019125622*^9}},
 CellLabel->"Out[19]=",ExpressionUUID->"9a468723-4421-4492-973e-299342024a93"],

Cell[BoxData[
 RowBox[{"-", "4"}]], "Output",
 CellChangeTimes->{
  3.7512869720591235`*^9, 3.7512870058660774`*^9, 3.7513458151611423`*^9, 
   3.751346831569708*^9, {3.751375991843026*^9, 3.75137601912959*^9}},
 CellLabel->"Out[20]=",ExpressionUUID->"dcd1cd96-349d-4665-9b23-4da1ece5a937"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.7512869720591235`*^9, 3.7512870058660774`*^9, 3.7513458151611423`*^9, 
   3.751346831569708*^9, {3.751375991843026*^9, 3.751376019135044*^9}},
 CellLabel->"Out[21]=",ExpressionUUID->"5bbad28a-9a3e-4733-975b-05125770e49e"],

Cell[BoxData[
 RowBox[{"-", 
  SqrtBox["3"]}]], "Output",
 CellChangeTimes->{
  3.7512869720591235`*^9, 3.7512870058660774`*^9, 3.7513458151611423`*^9, 
   3.751346831569708*^9, {3.751375991843026*^9, 3.7513760191395063`*^9}},
 CellLabel->"Out[22]=",ExpressionUUID->"33fdcbed-3e29-4377-b7b0-fbecb023ba3d"],

Cell[BoxData[
 RowBox[{"-", "7"}]], "Output",
 CellChangeTimes->{
  3.7512869720591235`*^9, 3.7512870058660774`*^9, 3.7513458151611423`*^9, 
   3.751346831569708*^9, {3.751375991843026*^9, 3.7513760191449656`*^9}},
 CellLabel->"Out[23]=",ExpressionUUID->"8b3d5dba-9ffe-4208-86f2-f2634819bc29"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.7512869720591235`*^9, 3.7512870058660774`*^9, 3.7513458151611423`*^9, 
   3.751346831569708*^9, {3.751375991843026*^9, 3.751376019148935*^9}},
 CellLabel->"Out[24]=",ExpressionUUID->"e335b60d-8513-4354-bb26-cb0e5107bdd7"],

Cell[BoxData[
 SqrtBox["3"]], "Output",
 CellChangeTimes->{
  3.7512869720591235`*^9, 3.7512870058660774`*^9, 3.7513458151611423`*^9, 
   3.751346831569708*^9, {3.751375991843026*^9, 3.7513760191544228`*^9}},
 CellLabel->"Out[25]=",ExpressionUUID->"ee58231d-d867-48b7-9aba-c2982f79a9a6"],

Cell[BoxData[
 RowBox[{"-", "7"}]], "Output",
 CellChangeTimes->{
  3.7512869720591235`*^9, 3.7512870058660774`*^9, 3.7513458151611423`*^9, 
   3.751346831569708*^9, {3.751375991843026*^9, 3.751376019160837*^9}},
 CellLabel->"Out[26]=",ExpressionUUID->"d5b55f26-efec-4d62-960f-a9fa98b36e5f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "Newton\:8fed\:4ee3\:6cd5\:6536\:655b\:503c", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"N", "[", 
    RowBox[{
     RowBox[{"Abs", "[", 
      RowBox[{
       RowBox[{"phi3", "[", "0", "]"}], "/", "6"}], "]"}], ",", "16"}], "]"}],
    "\[IndentingNewLine]", 
   RowBox[{"N", "[", 
    RowBox[{
     RowBox[{"Abs", "[", 
      RowBox[{
       RowBox[{"phi2", "[", 
        RowBox[{"-", 
         RowBox[{"Sqrt", "[", "3", "]"}]}], "]"}], "/", "2"}], "]"}], ",", 
     "16"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"N", "[", 
    RowBox[{
     RowBox[{"Abs", "[", 
      RowBox[{
       RowBox[{"phi2", "[", 
        RowBox[{"Sqrt", "[", "3", "]"}], "]"}], "/", "2"}], "]"}], ",", 
     "16"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7513458788270626`*^9, 3.7513459768684616`*^9}, {
  3.7513468202850037`*^9, 3.7513468270575514`*^9}, {3.751347047524596*^9, 
  3.7513470588856316`*^9}, {3.751347125457782*^9, 3.751347128020706*^9}},
 CellLabel->
  "In[112]:=",ExpressionUUID->"8c3221db-8acd-40d9-89da-f1ecaa564f19"],

Cell[BoxData["0.66666666666666666666666666666666666667`16."], "Output",
 CellChangeTimes->{3.751345938879881*^9, 3.7513459777684903`*^9, 
  3.751346833771555*^9, 3.751347065590206*^9, 3.7513471300031967`*^9},
 CellLabel->
  "Out[112]=",ExpressionUUID->"30154c79-d8a9-49c0-bd1d-3258bbe7f9fe"],

Cell[BoxData["0.86602540378443864676372317075293618347`16."], "Output",
 CellChangeTimes->{3.751345938879881*^9, 3.7513459777684903`*^9, 
  3.751346833771555*^9, 3.751347065590206*^9, 3.751347130009149*^9},
 CellLabel->
  "Out[113]=",ExpressionUUID->"14f4411c-aa6c-4277-ae86-910dd7538946"],

Cell[BoxData["0.86602540378443864676372317075293618347`16."], "Output",
 CellChangeTimes->{3.751345938879881*^9, 3.7513459777684903`*^9, 
  3.751346833771555*^9, 3.751347065590206*^9, 3.751347130011628*^9},
 CellLabel->
  "Out[114]=",ExpressionUUID->"06ff3754-1db8-46c6-ad6b-3f123c692042"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", "x_", "]"}], "=", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "^", "3"}], "/", "3"}], "-", "x"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f1", "[", "x_", "]"}], "=", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"f", "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "1"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f2", "[", "x_", "]"}], "=", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"f", "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "2"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"f3", "[", "x_", "]"}], "=", 
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"f", "[", "x", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "3"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{
  "(*", "\:5f26\:622a\:6cd5\:6536\:655b\:503c", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Abs", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"f3", "[", "0", "]"}], "/", "6"}], "/", 
      RowBox[{"f1", "[", "0", "]"}]}], "]"}], "^", 
    RowBox[{"(", 
     RowBox[{"2", "/", "3"}], ")"}]}], ",", "16"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Abs", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"f2", "[", 
        RowBox[{"Sqrt", "[", "3", "]"}], "]"}], "/", "2"}], "/", 
      RowBox[{"f1", "[", 
       RowBox[{"Sqrt", "[", "3", "]"}], "]"}]}], "]"}], "^", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Sqrt", "[", "5", "]"}], "-", "1"}], ")"}], "/", "2"}], 
     ")"}]}], ",", "16"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Abs", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"f2", "[", 
        RowBox[{"-", 
         RowBox[{"Sqrt", "[", "3", "]"}]}], "]"}], "/", "2"}], "/", 
      RowBox[{"f1", "[", 
       RowBox[{"-", 
        RowBox[{"Sqrt", "[", "3", "]"}]}], "]"}]}], "]"}], "^", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Sqrt", "[", "5", "]"}], "-", "1"}], ")"}], "/", "2"}], 
     ")"}]}], ",", "16"}], "]"}]}], "Input",
 CellChangeTimes->{{3.7512869391916847`*^9, 3.7512869404724226`*^9}, {
  3.7513460552904053`*^9, 3.7513461606074567`*^9}, {3.751346252926293*^9, 
  3.7513462874489965`*^9}, {3.7513463434344616`*^9, 3.751346410522603*^9}, {
  3.7513464721466594`*^9, 3.7513464799013057`*^9}, {3.751346524486252*^9, 
  3.7513465515236807`*^9}, {3.751346585196866*^9, 3.75134662366028*^9}, {
  3.751346667796549*^9, 3.7513467010704374`*^9}, {3.7513468521801357`*^9, 
  3.7513468570301523`*^9}, {3.7513469994054117`*^9, 3.751347029213183*^9}, {
  3.751347092013652*^9, 3.751347120704341*^9}, {3.7513633498245487`*^9, 
  3.751363453040821*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"28236405-1604-40b2-a9f3-94a8e03e7238"],

Cell[BoxData["0.48074985676913612744054610359335242533`16."], "Output",
 CellChangeTimes->{
  3.7513462876144*^9, 3.751346419405447*^9, 3.7513464885506983`*^9, 
   3.7513466257598205`*^9, {3.7513466828940554`*^9, 3.751346702541715*^9}, {
   3.7513468356137547`*^9, 3.7513468586069164`*^9}, 3.751347038237062*^9, 
   3.7513471319800997`*^9, {3.7513634292154045`*^9, 3.751363454688321*^9}},
 CellLabel->"Out[12]=",ExpressionUUID->"e919f9df-5b60-4e00-8b37-8e85b14887aa"],

Cell[BoxData["0.91493829845340521727816806945386349449`16."], "Output",
 CellChangeTimes->{
  3.7513462876144*^9, 3.751346419405447*^9, 3.7513464885506983`*^9, 
   3.7513466257598205`*^9, {3.7513466828940554`*^9, 3.751346702541715*^9}, {
   3.7513468356137547`*^9, 3.7513468586069164`*^9}, 3.751347038237062*^9, 
   3.7513471319800997`*^9, {3.7513634292154045`*^9, 3.751363454692289*^9}},
 CellLabel->"Out[13]=",ExpressionUUID->"a3ee7351-f009-46f4-965c-f1a6c31c8f6d"],

Cell[BoxData["0.91493829845340521727816806945386349449`16."], "Output",
 CellChangeTimes->{
  3.7513462876144*^9, 3.751346419405447*^9, 3.7513464885506983`*^9, 
   3.7513466257598205`*^9, {3.7513466828940554`*^9, 3.751346702541715*^9}, {
   3.7513468356137547`*^9, 3.7513468586069164`*^9}, 3.751347038237062*^9, 
   3.7513471319800997`*^9, {3.7513634292154045`*^9, 3.7513634546947694`*^9}},
 CellLabel->"Out[14]=",ExpressionUUID->"a6158dc1-b952-4c88-bec5-c1cb559c2d37"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.751345809285571*^9, 
  3.751345809307393*^9}},ExpressionUUID->"089f69f2-cba9-422b-a03c-\
857d2050eea5"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.751345808173668*^9, 
  3.7513458081850758`*^9}},ExpressionUUID->"78bd6b76-c516-4456-86dc-\
c2696e577f76"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.7513458072844324`*^9, 
  3.751345807349674*^9}},ExpressionUUID->"a2e6d903-fc9c-40f4-8621-\
84f0e357467f"]
},
WindowSize->{759, 581},
WindowMargins->{{Automatic, 295}, {24, Automatic}},
FrontEndVersion->"11.3 for Microsoft Windows (64-bit) (2018\:5e743\:670828\
\:65e5)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 2242, 60, 435, "Input",ExpressionUUID->"c0de3039-c059-4098-835a-6ad21893b685"],
Cell[2825, 84, 462, 12, 63, "Output",ExpressionUUID->"5d0f6633-8005-4cab-8331-56975a0cf2a2"],
Cell[3290, 98, 600, 17, 63, "Output",ExpressionUUID->"68724f49-a022-425b-b398-adde57df892b"],
Cell[3893, 117, 554, 15, 63, "Output",ExpressionUUID->"7cc1dbcc-e3e4-4660-ac04-b04f26c610af"],
Cell[4450, 134, 609, 17, 63, "Output",ExpressionUUID->"872a1c0d-825d-456a-98d6-39fc93857a23"],
Cell[5062, 153, 276, 4, 32, "Output",ExpressionUUID->"60851557-4efc-4eb3-83ae-c511664f59cb"],
Cell[5341, 159, 274, 4, 32, "Output",ExpressionUUID->"9a468723-4421-4492-973e-299342024a93"],
Cell[5618, 165, 290, 5, 32, "Output",ExpressionUUID->"dcd1cd96-349d-4665-9b23-4da1ece5a937"],
Cell[5911, 172, 274, 4, 32, "Output",ExpressionUUID->"5bbad28a-9a3e-4733-975b-05125770e49e"],
Cell[6188, 178, 305, 6, 36, "Output",ExpressionUUID->"33fdcbed-3e29-4377-b7b0-fbecb023ba3d"],
Cell[6496, 186, 293, 5, 32, "Output",ExpressionUUID->"8b3d5dba-9ffe-4208-86f2-f2634819bc29"],
Cell[6792, 193, 274, 4, 32, "Output",ExpressionUUID->"e335b60d-8513-4354-bb26-cb0e5107bdd7"],
Cell[7069, 199, 287, 5, 36, "Output",ExpressionUUID->"ee58231d-d867-48b7-9aba-c2982f79a9a6"],
Cell[7359, 206, 291, 5, 32, "Output",ExpressionUUID->"d5b55f26-efec-4d62-960f-a9fa98b36e5f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7687, 216, 1076, 30, 138, "Input",ExpressionUUID->"8c3221db-8acd-40d9-89da-f1ecaa564f19"],
Cell[8766, 248, 291, 4, 32, "Output",ExpressionUUID->"30154c79-d8a9-49c0-bd1d-3258bbe7f9fe"],
Cell[9060, 254, 289, 4, 32, "Output",ExpressionUUID->"14f4411c-aa6c-4277-ae86-910dd7538946"],
Cell[9352, 260, 289, 4, 32, "Output",ExpressionUUID->"06ff3754-1db8-46c6-ad6b-3f123c692042"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9678, 269, 3019, 91, 268, "Input",ExpressionUUID->"28236405-1604-40b2-a9f3-94a8e03e7238"],
Cell[12700, 362, 467, 6, 32, "Output",ExpressionUUID->"e919f9df-5b60-4e00-8b37-8e85b14887aa"],
Cell[13170, 370, 467, 6, 32, "Output",ExpressionUUID->"a3ee7351-f009-46f4-965c-f1a6c31c8f6d"],
Cell[13640, 378, 469, 6, 32, "Output",ExpressionUUID->"a6158dc1-b952-4c88-bec5-c1cb559c2d37"]
}, Open  ]],
Cell[14124, 387, 152, 3, 28, "Input",ExpressionUUID->"089f69f2-cba9-422b-a03c-857d2050eea5"],
Cell[14279, 392, 154, 3, 28, "Input",ExpressionUUID->"78bd6b76-c516-4456-86dc-c2696e577f76"],
Cell[14436, 397, 154, 3, 28, "Input",ExpressionUUID->"a2e6d903-fc9c-40f4-8621-84f0e357467f"]
}
]
*)

